<?php

/* connect to gmail */
$hostname = '{imap.gmail.com:993/imap/ssl}INBOX';
$username = 'VOTRE_EMAIL@gmail.com';
$password = 'VOTRE_PASSWORD';
//On prend que la derniere année
$date_min = (date("Y")-1)."-".date("m-d");

$replaces = array("CCHQ (X4000)"=>"Compte perso","CCHQ (X6181)"=>"Compte joint");
$disabled = array("Crédit à la consommation","Total","Total Epargne","Total Crédit");

require __DIR__ . '/vendor/simplehtmldom/simple_html_dom.php';


$blocs = array("maj"=>"2018-01-01","tab"=>array());
if (file_exists("comptes.txt")){
	$blocs = json_decode(file_get_contents("comptes.txt"),true);
}

if ($blocs["maj"] != date("Y-m-d")){
	/* try to connect */
	$connection = imap_open($hostname,$username,$password) or die('Cannot connect to Gmail: ' . imap_last_error());

	/* grab emails */
	//$emails = imap_search($connection,'ALL');
	$emails   = imap_search($connection, 'FROM "assistance@linxo.com" SINCE '.$blocs["maj"], SE_UID);
	set_time_limit(0);
	/* if emails are returned, cycle through each... */
	if($emails) {
		
		/* begin output var */
		$output = '';
		
		/* put the newest emails on top */
		//rsort($emails);
		
		/* for every email... */
		$Msgcount = count($emails);
		
		foreach($emails as $email_number) {
			$overview = imap_fetch_overview($connection,$email_number,FT_UID);
			$date = date("Y-m-d",$overview[0]->udate);
			
			$structure = imap_fetchstructure($connection, $email_number, FT_UID);

			if ($overview[0]->from == "Linxo <assistance@linxo.com>"){
				if(isset($structure->parts) && is_array($structure->parts) && isset($structure->parts[1])) {
					$part = $structure->parts[1];
					$message = imap_fetchbody($connection,$email_number,FT_UID);

					if($part->encoding == 3) {
						$message = imap_base64($message);
					} else if($part->encoding == 1) {
						$message = imap_8bit($message);
					} else {
						$message = imap_qprint($message);
					}
				}else{
					$message = imap_qprint(imap_body($connection,$email_number,FT_UID));
				}
				
				if (imap_utf8($overview[0]->subject) == "Synthèse hebdomadaire"){				
					$html = str_get_html($message); 

					$items = $html->find('//tr/td/h2');
					foreach ($items as $item){	
						$sBloc = trim($item->innerText());
						if ($sBloc != "A faire" and $sBloc != "Notifications"){
							if (!isset($blocs["tab"][$sBloc])){
								$blocs["tab"][$sBloc] = array();
							}
							
							$comptes = $item->parent()->find("table/tr/td");
							$i = 0;
							foreach ($comptes as $compte){
								$attrs = $compte->getAllAttributes();
								if (!isset($attrs["colspan"])){
									$i++;
									switch ($i){								
										case 1:
											$id_compte = rep($compte->plaintext,false);
											break;
										case 2:
											if (!isset($blocs["tab"][$sBloc][$id_compte])){
												$blocs["tab"][$sBloc][$id_compte] = array();
											}
											if (!isset($blocs["tab"][$sBloc][$id_compte][$date])){
												$blocs["tab"][$sBloc][$id_compte][$date] = array();
											}
											$blocs["tab"][$sBloc][$id_compte][$date] = rep($compte->plaintext,true);										
											$id_compte = "";
											$i=0;
											break;
									}			
								}
							}
						}
					}
				}
			}
		}
		
		$blocs["maj"] = date("Y-m-d");
		file_put_contents("comptes.txt",json_encode($blocs));
	}
	
	/* close the connection */
	imap_close($connection);

}


function rep($s, $bRemoveWhitespace){
	global $replaces;
	$infos = explode("\n",$s);
	$s = $infos[0];
	
	//$s = str_replace("Crédit Agricole - Atlantique-Vendée","",$s);	
	
	if ($bRemoveWhitespace){
		//echo chr(160);exit();
		//echo ord(substr($s,2,1));exit();
		
		$s = str_replace("€","",$s);
		$s = str_replace(",",".",$s);
		$s = str_replace(" ","",$s);
	
		$iPos = strpos($s,chr(32));
		if ($iPos>0){
			$s = substr($s,0,$iPos);
		}
		
		$s = str_replace(chr(194).chr(160),"",$s);
		$iPos = strpos($s,"Dernière");
		if ($iPos>0){
			$s = substr($s,0,$iPos);
		}
	}
	
	$s = trim($s);
	return $s;
}


//echo var_dump($blocs);

?>

<html>
	<head>
	<script src="https://code.highcharts.com/highcharts.js"></script>
	</head>
	<body>
		<?php
		foreach ($blocs["tab"] as $bloc=>$infosBloc){
			$sMonths = "";
			foreach ($infosBloc as $id_compte=>$dates){
				foreach ($dates as $date=>$value){
					if ($date>=$date_min){
						$sMonths .= "'".substr($date,8,2)."-".substr($date,5,2)."',";
					}
				}
			}
		?>
			<div id="container_<?php echo md5($bloc);?>" style="width:98%; height:300px;"></div>
			<script>
			Highcharts.chart('container_<?php echo md5($bloc);?>', {
				chart: {
					type: 'line'
				},
				title: {
					text: '<?php echo $bloc;?>'
				},
				subtitle: {
					text: 'Source: linxo.com'
				},
				xAxis: {
						categories: [<?php echo $sMonths;?>]
				},
				yAxis: {
					title: {
						text: 'Euros'
					}
				},
				legend: {
					layout: 'vertical',
					align: 'right',
					verticalAlign: 'middle'
				},

				plotOptions: {
					line: {
						dataLabels: {
							enabled: false
						},
						enableMouseTracking: true
					}
				},

				series: [
				<?php
				foreach ($infosBloc as $id_compte=>$dates){
					if (!in_array($id_compte, $disabled)){
						$sValue = "";
						foreach ($dates as $date=>$value){
							if ($date>=$date_min){
								$sValue .= $value.",";
							}
						}
						
						
						//Remplace certains libelles
						foreach ($replaces as $find=>$replace){
							$id_compte = str_replace($find,$replace,$id_compte);
						}
						
						//if ($id_compte != "Total"){
						?>
							{
							name: "<?php echo $id_compte;?>",
							data: [<?php echo $sValue;?>]
							},
						<?php
					//}
					}
				}
				?>
				],
				responsive: {
					rules: [{
						condition: {
							maxWidth: 500
						},
						chartOptions: {
							legend: {
								layout: 'horizontal',
								align: 'center',
								verticalAlign: 'bottom'
							}
						}
					}]
				}

			});
			</script>
		<?php
		}
		?>
	</body>
</html>